###############################################################################
#  Makefile for PortForwarder. This needs OpenSSL patched for PortForwarder.
###############################################################################
SRC_D	= .
PFSRC_D	= ..
SSL_D	= ..\openssl-0.9.5a
DMY_INCD	= ..\dummy_include

!if "$(TYPE)" == "HPCPRO-MIPS"
SOUT_D	= outHPCPRO-MIPS
STMP_D	= tmpHPCPRO-MIPS
SINC_D	= incHPCPRO-MIPS
OUT_D	= ..\HPCPRO-MIPS
!else if "$(TYPE)" == "HPCPRO-SH3"
SOUT_D	= outHPCPRO-SH3
STMP_D	= tmpHPCPRO-SH3
SINC_D	= incHPCPRO-SH3
OUT_D	= ..\HPCPRO-SH3
!else if "$(TYPE)" == "HPCPRO-SH4"
SOUT_D	= outHPCPRO-SH4
STMP_D	= tmpHPCPRO-SH4
SINC_D	= incHPCPRO-SH4
OUT_D	= ..\HPCPRO-SH4
!else if "$(TYPE)" == "HPCPRO-ARM"
SOUT_D	= outHPCPRO-ARM
STMP_D	= tmpHPCPRO-ARM
SINC_D	= incHPCPRO-ARM
OUT_D	= ..\HPCPRO-ARM
!else if "$(TYPE)" == "POCKETPC-MIPS"
SOUT_D	= outPOCKETPC-MIPS
STMP_D	= tmpPOCKETPC-MIPS
SINC_D	= incPOCKETPC-MIPS
OUT_D	= ..\POCKETPC-MIPS
!else if "$(TYPE)" == "POCKETPC-SH3"
SOUT_D	= outPOCKETPC-SH3
STMP_D	= tmpPOCKETPC-SH3
SINC_D	= incPOCKETPC-SH3
OUT_D	= ..\POCKETPC-SH3
!else if "$(TYPE)" == "POCKETPC-ARM"
SOUT_D	= outPOCKETPC-ARM
STMP_D	= tmpPOCKETPC-ARM
SINC_D	= incPOCKETPC-ARM
OUT_D	= ..\POCKETPC-ARM
!else
SOUT_D	= out32
STMP_D	= tmp32
SINC_D	= inc32
OUT_D	= ..\WIN
!endif
TMP_D	= $(STMP_D)
INC1_D	= $(SSL_D)\include
INC2_D	= $(DMY_INCD)

SSL_LIB	= $(SSL_D)\$(SOUT_D)\ssleay32.lib $(SSL_D)\$(SOUT_D)\libeay32.lib
TARGET	= PortForwarder.exe
TARGET2	= PF-keygen.exe

INC	= /I$(INC1_D) /I$(INC2_D) /I$(PFSRC_D) /I$(SRC_D)

###############################################################################
!if "$(DEBUG)" == ""
DBG	= /D NDEBUG
!else
DBG	= /D _DEBUG
!endif

!if "$(LOG)" == ""
LOG2	=
!else
LOG2	= /D _LOG_
!endif

###############################################################################
# set compiler option
!if "$(TYPE)" == "HPCPRO-MIPS"
CC	= clmips.exe
CEVersion=211
CePlatform=WIN32_PLATFORM_HPCPRO
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "MIPS" /D "_MIPS_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "MIPS" /d "_MIPS_" /r
!else if "$(TYPE)" == "HPCPRO-SH3"
CC	= shcl.exe
CEVersion=211
CePlatform=WIN32_PLATFORM_HPCPRO
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "SHx" /D "SH3" /D "_SH3_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "SHx" /d "SH3" /d "_SH3_" /r
!else if "$(TYPE)" == "HPCPRO-SH4"
CC	= shcl.exe
CEVersion=211
CePlatform=WIN32_PLATFORM_HPCPRO
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "SHx" /D "SH4" /D "_SH4_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /Qsh4 /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "SHx" /d "SH4" /d "_SH4_" /r
!else if "$(TYPE)" == "HPCPRO-ARM"
CC	= clarm.exe
CEVersion=211
CePlatform=WIN32_PLATFORM_HPCPRO
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "ARM" /D "_ARM_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "ARM" /d "_ARM_" /r
!else if "$(TYPE)" == "POCKETPC-MIPS"
CC	= clmips.exe
CEVersion=300
CePlatform=WIN32_PLATFORM_PSPC
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE_PSPC /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "MIPS" /D "_MIPS_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "MIPS" /d "_MIPS_" /r
!else if "$(TYPE)" == "POCKETPC-SH3"
CC	= shcl.exe
CEVersion=300
CePlatform=WIN32_PLATFORM_PSPC
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE_PSPC /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "SHx" /D "SH3" /D "_SH3_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "SHx" /d "SH3" /d "_SH3_" /r
!else if "$(TYPE)" == "POCKETPC-ARM"
CC	= clarm.exe
CEVersion=300
CePlatform=WIN32_PLATFORM_PSPC
CFLAG	= $(INC) /WX /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2) /nologo /W3 /GX- /D _WIN32_WCE_PSPC /D _WIN32_WCE=$(CEVersion) /D "$(CePlatform)" /D "ARM" /D "_ARM_" /D UNDER_CE=$(CEVersion) /D "UNICODE" /D "_UNICODE" /D "NDEBUG" /O2 /Oxs /MC /c
RSC	= rc.exe
RFLAG	= /d UNDER_CE=$(CEVersion) /d _WIN32_WCE=$(CEVersion) /d "UNICODE" /d "_UNICODE" /d "$(CePlatform)" /d "ARM" /d "_ARM_" /r
!else
CC	= cl.exe
CFLAG= $(INC) /ML /W3 /WX /Ox /O2 /c /nologo /D WIN32 /D "_MBCS" /D _WINDOWS /D NO_FP_API /D IPV4_DEFAULT /D HAVE_OPENSSL /D _OPENSSH_ /D _TOH_ $(DBG) $(LOG2)
RSC	= rc.exe
RFLAG	= /r
!endif

###############################################################################
# set linker option
!if "$(TYPE)" == "HPCPRO-MIPS"
CESubsystem=windowsce,2.11
CENoDefaultLib=libc.lib /nodefaultlib:libcd.lib /nodefaultlib:libcmt.lib /nodefaultlib:libcmtd.lib /nodefaultlib:msvcrt.lib /nodefaultlib:msvcrtd.lib
LINK	= link.exe
LFLAG	=  commctrl.lib coredll.lib /nologo /entry:"WinMainCRTStartup" /nodefaultlib:$(CENoDefaultLib) /subsystem:$(CESubsystem) /MACHINE:MIPS winsock.lib $(SSL_LIB)
!else if "$(TYPE)" == "HPCPRO-SH3"
CESubsystem=windowsce,2.11
CENoDefaultLib=libc.lib /nodefaultlib:libcd.lib /nodefaultlib:libcmt.lib /nodefaultlib:libcmtd.lib /nodefaultlib:msvcrt.lib /nodefaultlib:msvcrtd.lib
LINK	= link.exe
LFLAG	=  commctrl.lib coredll.lib /nologo /entry:"WinMainCRTStartup" /nodefaultlib:$(CENoDefaultLib) /subsystem:$(CESubsystem) /MACHINE:SH3 winsock.lib $(SSL_LIB)
!else if "$(TYPE)" == "HPCPRO-SH4"
CESubsystem=windowsce,2.11
CENoDefaultLib=libc.lib /nodefaultlib:libcd.lib /nodefaultlib:libcmt.lib /nodefaultlib:libcmtd.lib /nodefaultlib:msvcrt.lib /nodefaultlib:msvcrtd.lib
LINK	= link.exe
LFLAG	=  commctrl.lib coredll.lib /nologo /entry:"WinMainCRTStartup" /nodefaultlib:$(CENoDefaultLib) /subsystem:$(CESubsystem) /MACHINE:SH4 winsock.lib $(SSL_LIB)
!else if "$(TYPE)" == "HPCPRO-ARM"
CESubsystem=windowsce,2.11
CENoDefaultLib=libc.lib /nodefaultlib:libcd.lib /nodefaultlib:libcmt.lib /nodefaultlib:libcmtd.lib /nodefaultlib:msvcrt.lib /nodefaultlib:msvcrtd.lib
LINK	= link.exe
LFLAG	=  commctrl.lib coredll.lib /nologo /entry:"WinMainCRTStartup" /nodefaultlib:$(CENoDefaultLib) /subsystem:$(CESubsystem) /MACHINE:ARM winsock.lib $(SSL_LIB)
!else if "$(TYPE)" == "POCKETPC-MIPS"
CESubsystem=windowsce,3.00
LINK	= link.exe
LFLAG	=  /nologo /entry:"WinMainCRTStartup" /subsystem:$(CESubsystem) /MACHINE:MIPS winsock.lib aygshell.lib $(SSL_LIB)
!else if "$(TYPE)" == "POCKETPC-SH3"
CESubsystem=windowsce,3.00
LINK	= link.exe
LFLAG	=  /nologo /entry:"WinMainCRTStartup" /subsystem:$(CESubsystem) /MACHINE:SH3 winsock.lib aygshell.lib $(SSL_LIB)
!else if "$(TYPE)" == "POCKETPC-ARM"
CESubsystem=windowsce,3.00
LINK	= link.exe
LFLAG	=  /nologo /entry:"WinMainCRTStartup" /subsystem:$(CESubsystem) /MACHINE:ARM winsock.lib aygshell.lib $(SSL_LIB)
!else
LINK	= link.exe
LFLAG	= wsock32.lib user32.lib gdi32.lib advapi32.lib shell32.lib comdlg32.lib $(SSL_LIB) /nologo /machine:i386 /subsystem:windows
!endif

###############################################################################
# commands
RM	= del
RMDIR	= rd
MKDIR	= mkdir
CP	= copy

###############################################################################
OBJS	= $(TMP_D)\TohCommon.obj \
	$(TMP_D)\ssh.obj $(TMP_D)\readconf.obj $(TMP_D)\malloc_dummy.obj \
	$(TMP_D)\match.obj $(TMP_D)\cipher.obj $(TMP_D)\xmalloc.obj \
	$(TMP_D)\sshconnect.obj $(TMP_D)\packet.obj $(TMP_D)\log.obj \
	$(TMP_D)\buffer.obj $(TMP_D)\FmtMsg.obj $(TMP_D)\fingerprint.obj \
	$(TMP_D)\bufaux.obj $(TMP_D)\atomicio.obj $(TMP_D)\mpaux.obj \
	$(TMP_D)\deattack.obj $(TMP_D)\crc32.obj $(TMP_D)\compat.obj \
	$(TMP_D)\channels.obj $(TMP_D)\rsa.obj $(TMP_D)\authfile.obj \
	$(TMP_D)\hostfile.obj $(TMP_D)\nchan.obj $(TMP_D)\clientloop.obj \
	$(TMP_D)\canohost.obj $(TMP_D)\LoadSaveInfo.obj $(TMP_D)\FindFile.obj \
	$(TMP_D)\bsd-strlcpy.obj $(TMP_D)\fake-getaddrinfo.obj \
	$(TMP_D)\fake-getnameinfo.obj $(TMP_D)\bsd-misc.obj $(TMP_D)\random.obj

MAIN_OBJS	= $(TMP_D)\pfmain.obj $(TMP_D)\resource.res

OBJS2	= $(TMP_D)\resource2.res $(TMP_D)\pf-keygen.obj \
	$(TMP_D)\ssh-keygen.obj $(TMP_D)\bsd-strlcat.obj

###############################################################################
all: $(INC1_D) $(OUT_D) $(TMP_D) exe

$(INC1_D):
	$(MKDIR) $(INC1_D)
	$(MKDIR) $(INC1_D)\openssl
	$(CP) $(SSL_D)\$(SINC_D)\openssl\*.* $(INC1_D)\openssl
$(OUT_D):
	$(MKDIR) $(OUT_D)

$(TMP_D):
	$(MKDIR) $(TMP_D)

exe: $(OUT_D)\$(TARGET) $(OUT_D)\$(TARGET2)

clean:
	$(RM) $(TMP_D)\*.*
	$(RMDIR) $(TMP_D)

clean_all:
	$(RM) $(TMP_D)\*.*
	$(RMDIR) $(TMP_D)
	$(RM) $(OUT_D)\*.*
	$(RMDIR) $(OUT_D)

$(OUT_D)\$(TARGET): $(MAIN_OBJS) $(OBJS) $(SSL_LIB)
	$(LINK) $(LFLAG) /out:"$(OUT_D)\$(TARGET)" $(OBJS) $(MAIN_OBJS)

$(OUT_D)\$(TARGET2): $(OBJS) $(OBJS2) $(SSL_LIB)
	$(LINK) $(LFLAG) /out:"$(OUT_D)\$(TARGET2)" $(OBJS) $(OBJS2)

$(TMP_D)\resource.res: $(PFSRC_D)\resource.rc
	$(RSC) /fo$@ $(RFLAG) $(PFSRC_D)\resource.rc
$(TMP_D)\pfmain.obj: $(PFSRC_D)\pfmain.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\pfmain.c
$(TMP_D)\TohCommon.obj: $(PFSRC_D)\TohCommon.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\TohCommon.c
$(TMP_D)\ssh.obj: $(SRC_D)\ssh.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\ssh.c
$(TMP_D)\readconf.obj: $(SRC_D)\readconf.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\readconf.c
$(TMP_D)\match.obj: $(SRC_D)\match.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\match.c
$(TMP_D)\cipher.obj: $(SRC_D)\cipher.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\cipher.c
$(TMP_D)\xmalloc.obj: $(SRC_D)\xmalloc.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\xmalloc.c
$(TMP_D)\sshconnect.obj: $(SRC_D)\sshconnect.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\sshconnect.c
$(TMP_D)\packet.obj: $(SRC_D)\packet.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\packet.c
$(TMP_D)\log.obj: $(SRC_D)\log.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\log.c
$(TMP_D)\buffer.obj: $(SRC_D)\buffer.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\buffer.c
$(TMP_D)\FmtMsg.obj: $(PFSRC_D)\FmtMsg.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\FmtMsg.c
$(TMP_D)\fingerprint.obj: $(SRC_D)\fingerprint.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\fingerprint.c
$(TMP_D)\bufaux.obj: $(SRC_D)\bufaux.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\bufaux.c
$(TMP_D)\atomicio.obj: $(SRC_D)\atomicio.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\atomicio.c
$(TMP_D)\mpaux.obj: $(SRC_D)\mpaux.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\mpaux.c
$(TMP_D)\deattack.obj: $(SRC_D)\deattack.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\deattack.c
$(TMP_D)\crc32.obj: $(SRC_D)\crc32.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\crc32.c
$(TMP_D)\compat.obj: $(SRC_D)\compat.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\compat.c
$(TMP_D)\channels.obj: $(SRC_D)\channels.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\channels.c
$(TMP_D)\rsa.obj: $(SRC_D)\rsa.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\rsa.c
$(TMP_D)\authfile.obj: $(SRC_D)\authfile.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\authfile.c
$(TMP_D)\hostfile.obj: $(SRC_D)\hostfile.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\hostfile.c
$(TMP_D)\nchan.obj: $(SRC_D)\nchan.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\nchan.c
$(TMP_D)\clientloop.obj: $(SRC_D)\clientloop.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\clientloop.c
$(TMP_D)\canohost.obj: $(SRC_D)\canohost.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\canohost.c
$(TMP_D)\LoadSaveInfo.obj: $(PFSRC_D)\LoadSaveInfo.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\LoadSaveInfo.c
$(TMP_D)\FindFile.obj: $(PFSRC_D)\FindFile.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\FindFile.c
$(TMP_D)\bsd-strlcpy.obj: $(SRC_D)\bsd-strlcpy.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\bsd-strlcpy.c
$(TMP_D)\fake-getaddrinfo.obj: $(SRC_D)\fake-getaddrinfo.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\fake-getaddrinfo.c
$(TMP_D)\fake-getnameinfo.obj: $(SRC_D)\fake-getnameinfo.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\fake-getnameinfo.c
$(TMP_D)\bsd-misc.obj: $(SRC_D)\bsd-misc.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\bsd-misc.c
$(TMP_D)\random.obj: $(SRC_D)\random.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\random.c
$(TMP_D)\malloc_dummy.obj: $(PFSRC_D)\malloc_dummy.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\malloc_dummy.c

$(TMP_D)\resource2.res: $(PFSRC_D)\resource2.rc
	$(RSC) /fo$@ $(RFLAG) $(PFSRC_D)\resource2.rc
$(TMP_D)\pf-keygen.obj: $(PFSRC_D)\pf-keygen.c
	$(CC) /Fo$@ $(CFLAG) $(PFSRC_D)\pf-keygen.c
$(TMP_D)\ssh-keygen.obj: $(SRC_D)\ssh-keygen.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\ssh-keygen.c
$(TMP_D)\bsd-strlcat.obj: $(SRC_D)\bsd-strlcat.c
	$(CC) /Fo$@ $(CFLAG) $(SRC_D)\bsd-strlcat.c
